<?php 
include "vendor/autoload.php";
use GuzzleHttp\Client;
use phpseclib\Crypt\RSA;
use Illuminate\Support\Str;

if(!function_exists('debug')){
    function debug($v, $die = true){
        echo "<pre>";
        print_r($v);
        echo "</pre>";
        if($die)
            die();

    }
}

$options = array(
  'cluster' => 'ap1',
  'useTLS' => true
);
$pusher = new Pusher\Pusher(
  'f934b82d669a20642e50',
  '859082d42015e5846960',
  '583990',
  $options
);


include "acb.php";


$data = file_get_contents('php://input');
if($data){
    $data = json_decode($data, true);
    $app = new ACB($data['username'], $data['password'], $data['accountNo']);

    switch ($data['action']) {

    	case 'login':
	    	echo json_encode($app->login($data['username'], $data['password']));
	    	break;
	    case 'transactions':
	    	$result = $app->getTransactions($data['accountNo'], $data['rows']);
	    	echo json_encode($result);
	    	break;
	    case 'balance':
	    	echo json_encode($app->getBalance());
	    	break;
	    case 'transfer': 
	    	// $result = $app->transferMoney($data['accountNo'], $data['bankNumber'], $data['bankCode'], $data['amount'], $data['message']);

	    	$res = $app->getBankInfo($data['bankCode'], $data['bankNumber'], $data['accountNo']);
	    	if(isset($res['data']['ownerName'])){
	    	    $res = $app->verifyTransfer($data['accountNo'], $res['data'], $data['amount'], $data['message'], $data['bankCode']);
	    	    if(isset($res['data']['uuid'])){
	    	        $uuid = $res['data']['uuid'];

        			file_put_contents('otp.txt', '');
    	    		$data['challenge'] = '';
    	    		$pusher->trigger('my-channel', 'get-otp-acb', $data);
    	    		sleep(10);
    	    		$flag = false;
		    		$count = 1;
		    		while (!$flag && $count < 5) {
	    	    		$otp = file_get_contents('otp.txt');
	    	    		if($otp)
	    	    			$flag = true;
			    		sleep(1);
			    		$count++;
		    		}
    	    		if($otp){
    	    			$res = $app->confirmTransfer($uuid, $otp);
    	    		}


	    	    }
	    	}

	    	echo json_encode($res);
    		break;

    	case 'transfer_in': 
	    	if($data['otp'] && $data['tranToken'])
	    		$result = $app->transferMoney($data['tranToken'], $data['otp'], 2);
	    	else
		    	$result = $app->transferMoneyInt2($data['amount'], $data['content'], ['acc' => $data['banknumber']], $data['accNo']);

			echo json_encode($result);
    		break;

    	default:
    		// code...
    		break;
    }
    
}
else
    echo json_encode(['success' => 0]);
die();
